/* 
* classAC.cpp
*
* Created: 28/03/2021 0:23:45
* Author: Ledo
*/


#include "classAC.h"

// default constructor
classAC::classAC()
{
} //classAC

// default destructor
classAC::~classAC()
{
} //~classAC

// Analog Comparator(s) for PORTA initialization
void classAC::aca_init(void)
{
	// Voltage Scaling Factor: 0,016 * Vcc
	ACA.CTRLB=0;
	// Window Mode enabled: Off
	ACA.WINCTRL=(0<<AC_WEN_bp) | AC_WINTMODE_ABOVE_gc | AC_WINTLVL_OFF_gc;
	// AC0 Constant Current Source: Off
	// AC1 Constant Current Source: Off
	ACA.CURRCTRL=0x00;
	// AC0 Positive Input: Pin 3
	// AC0 Negative Input: Vcc Scaler
	ACA.AC0MUXCTRL=AC_MUXPOS_PIN3_gc | AC_MUXNEG_DAC_gc;
	// AC0 is enabled
	// AC0 Interrupt/Event Mode: Rising Edge
	// AC0 Interrupt Level: Low-level
	// AC0 High Speed Mode: On
	// AC0 Hysteresis: Small
	ACA.AC0CTRL=AC_INTMODE_RISING_gc | AC_INTLVL_OFF_gc | (1<<AC_HSMODE_bp) | AC_HYSMODE_SMALL_gc | (1<<AC_ENABLE_bp);
	// AC1 is disabled
	ACA.AC1CTRL=(0<<AC_ENABLE_bp);
	// AC0 Output on PORTA: No
	// AC1 Output on PORTA: No
	ACA.CTRLA=(0<<AC_AC1OUT_bp) | (0<<AC_AC0OUT_bp);
}

// Analog Comparator(s) for PORTA initialization
void classAC::aca_interrupt_on(void)
{
	ACA.AC0CTRL = 0;
	ACA.STATUS = 0x01;
	// AC0 is enabled
	// AC0 Interrupt/Event Mode: Rising Edge
	// AC0 Interrupt Level: Low-level
	// AC0 High Speed Mode: Off
	// AC0 Hysteresis: Small
	ACA.AC0CTRL=AC_INTMODE_RISING_gc | AC_INTLVL_LO_gc | (0<<AC_HSMODE_bp) | AC_HYSMODE_SMALL_gc | (1<<AC_ENABLE_bp);
}

// Analog Comparator(s) for PORTA initialization
void classAC::aca_interrupt_off(void)
{
	ACA.AC0CTRL = 0;
	ACA.STATUS = 0x01;
	// AC0 is enabled
	// AC0 Interrupt/Event Mode: Rising Edge
	// AC0 Interrupt Level: Low-level
	// AC0 High Speed Mode: On
	// AC0 Hysteresis: Small
	ACA.AC0CTRL=AC_INTMODE_RISING_gc | AC_INTLVL_OFF_gc | (1<<AC_HSMODE_bp) | AC_HYSMODE_SMALL_gc | (1<<AC_ENABLE_bp);
}


