/* 
* classAD7843.cpp
*
* Created: 06/02/2015 21:05:21
* Author: Vaio
*/


#include "classAD7843.h"

// default constructor
classAD7843::classAD7843()
{
	Points[1].ad7843_val_X = 31040;
	Points[1].ad7843_val_Y = 30464;
	Points[1].pixel_X = 320;
	Points[1].pixel_Y = 240;
	Points[0].ad7843_val_X = 2500;
	Points[0].ad7843_val_Y = 2136;
	Points[0].pixel_X = 0;
	Points[0].pixel_Y = 0;

} //classAD7843


void classAD7843::TCInit(void)
{
	
    PORTF.DIRSET = TP_CS | TP_SDI | TP_CLK;
	PORTF.DIRCLR = TP_PEN | TP_SDO;
    PORTF.OUTSET = TP_CS ;
	PORTF.PIN3CTRL=PORT_OPC_PULLUP_gc | PORT_ISC_FALLING_gc;
	TP_CS_HIGH();
	TP_CLK_LOW();
	TP_SDI_LOW();
}


// ads_rd():
// A bit-banged implementation of the SPI access for AD7843...
// Slow and steady gets the job done!
//

int16_t   classAD7843::ad7843_read(uint8_t ads_ctl)
{
	uint16_t bit, val;

	TP_CLK_LOW();
	TP_CS_LOW();

	for(bit = 0x80;bit != 0;bit >>= 1) {
		if (ads_ctl & bit)
		{
			TP_SDI_HIGH();
		}
		else
		{
			TP_SDI_LOW();
		
		}

		TP_CLK_HIGH();
		_delay_us(1);
		TP_CLK_LOW();
		_delay_us(1);//clk a 500 kHz
	}

	val = 0;
	for(bit = 0x8000;bit != 0;bit >>= 1)
	 {
		TP_CLK_HIGH();
		if (getTP_SDO())
		val |= bit;
		_delay_us(1);
		TP_CLK_LOW();
		_delay_us(1);
	}

	TP_CLK_LOW();
	_delay_us(1);
	TP_CS_HIGH();
	return(val);
}








unsigned int classAD7843::TCGetX(void) //call this after TCRead() to get X value
{
	int32_t temp;
	temp = ad7843_read(0x92);//0xD2
	return ((Points[1].pixel_X - Points[0].pixel_X) * (temp - Points[0].ad7843_val_X) /
	(Points[1].ad7843_val_X - Points[0].ad7843_val_X))
	+ Points[0].pixel_X;
}

unsigned int classAD7843::TCGetY(void) //call this after TCRead() to get Y value
{
	int32_t temp;
	temp = ad7843_read(0xD2);//0x92
	return ((Points[1].pixel_Y - Points[0].pixel_Y) * (temp - Points[0].ad7843_val_Y) /
	(Points[1].ad7843_val_Y - Points[0].ad7843_val_Y))
	+ Points[0].pixel_Y;}

unsigned char classAD7843::TCIsPenOn(void) //TC_PEN_PIN is 0 when the screen is pressed
{
	return ((PORTF.IN & TP_PEN)>0) ? 0 : 1;
}

			


void classAD7843::drawKeys(void)
{
	utft.fillScr(VGA_BLACK);
	drawButton("1",10,10,60,50);
	drawButton("2",75,10,60,50);
	drawButton("3",140,10,60,50);
	drawButton("4",10,65,60,50);
	drawButton("5",75,65,60,50);
	drawButton("6",140,65,60,50);
	drawButton("7",10,120,60,50);
	drawButton("8",75,120,60,50);
	drawButton("9",140,120,60,50);
	drawButton("DEL",10,175,60,50);
	drawButton("0",75,175,60,50);
	drawButton(".",140,175,60,50);
	drawButton("ENTER",208,80,100,80);
	drawButton("BACK",208,175,100,50);

	utft.drawRect(1,1,319,239);
	drawTexbox("",205,10,105,50);
    keyValue = 0;
}

void classAD7843::drawButton(char * string,uint16_t x, uint16_t y,uint8_t ancho, uint8_t alto)
{
	int16_t leng, dx, dy;
	utft.setColor(VGA_RED);
	utft.fillRect(x,y,x+ancho,y+alto);
    utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_RED);
	utft.setFont(font16x16);
	leng = strlen(string) * utft.getFontXsize();
	dx = (ancho - leng)/2;
	dy = (alto - utft.getFontYsize())/2;
	utft.print(string,x+dx,y+dy,0);
}

void classAD7843::drawTexbox(char * string,uint16_t x, uint16_t y,uint8_t ancho, uint8_t alto)
{
	int16_t leng, dx, dy;
	utft.setColor(VGA_WHITE);
	utft.fillRect(x,y,x+ancho,y+alto);
	utft.setColor(VGA_BLACK);
	utft.setBackColor(VGA_WHITE);
	utft.setFont(font16x16);
	leng = strlen(string) * utft.getFontXsize();
	dx = (ancho - leng)/2;
	dy = (alto - utft.getFontYsize())/2;
	utft.print(string,x+dx,y+dy,0);
}

void classAD7843::keyValue_print(uint8_t num)
{
	int16_t dy;
	if(num>100)
	return;
	utft.setColor(VGA_BLACK);
	utft.setBackColor(VGA_WHITE);
	utft.setFont(font16x16);
	utft.printNumI(num,205,20,3,'0');
}

void classAD7843::keyValue_print(uint32_t num)
{
	int16_t dy;
	if(num>1000000)
	 return;
	utft.setColor(VGA_BLACK);
	utft.setBackColor(VGA_WHITE);
	utft.setFont(font16x16);
	utft.printNumI(num,205,20,6,'0');
}

void classAD7843::keyValue_printF(void)
{
	utft.setColor(VGA_BLACK);
	utft.setBackColor(VGA_WHITE);
	utft.setFont(font16x16);
	utft.print(keyValueF,205,20,0);
}

uint8_t classAD7843::presetKey(void)
{
	if(TCGetX()<70)
	 return coll1_decode();
	if(TCGetX()> 70 && TCGetX()<140)
	return coll2_decode();
	if(TCGetX()> 140 && TCGetX()<205)
	return coll3_decode();
	if(TCGetX()>208)
	return coll4_decode();
	 return 0;
}

uint8_t classAD7843::coll1_decode(void)
{
	if(TCGetY()<60)
	 return 1;
	 
	if(TCGetY()>60 && TCGetY()< 120)
	 return 4;
	 
	if(TCGetY()>120 && TCGetY()< 175)
	 return 7;

	if(TCGetY()>175)
	return 10; //Del key
	 
}

uint8_t classAD7843::coll2_decode(void)
{
	if(TCGetY()<60)
	return 2;
	
	if(TCGetY()>60 && TCGetY()< 120)
	return 5;
	
	if(TCGetY()>120 && TCGetY()< 175)
	return 8;
	
	if(TCGetY()>175)
	 return 0;

}

uint8_t classAD7843::coll3_decode(void)
{
	if(TCGetY()<60)
	return 3;
	
	if(TCGetY()>60 && TCGetY()< 120)
	return 6;
	
	if(TCGetY()>120 && TCGetY()< 175)
	return 9;

	if(TCGetY()>175)
	return 11;//dot key
	
}

uint8_t classAD7843::coll4_decode(void)
{
	if(TCGetY()<170)
	return 12;//enter key
	
	if(TCGetY()>170)
	return 13;//back key
	
}




// default destructor
classAD7843::~classAD7843()
{
} //~classAD7843
