/* 
* classAD7843.h
*
* Created: 06/02/2015 21:05:22
* Author: Vaio
*/


#ifndef __CLASSAD7843_H__
#define __CLASSAD7843_H__

#include <avr/io.h>
#include <avr/portpins.h>
#include <math.h>
#include "UTFT.h"
#define F_CPU (32000000UL)
#include <util/delay.h>


#define TP_CS            PIN2_bm           //PORTF
#define TP_PEN           PIN3_bm           //PORTF
#define TP_SDI           PIN5_bm           //PORTF
#define TP_SDO           PIN6_bm           //PORTF
#define TP_CLK           PIN7_bm           //PORTF

#define TP_CS_LOW()      PORTF.OUTCLR = TP_CS;
#define TP_CS_HIGH()     PORTF.OUTSET = TP_CS;

#define TP_SDI_LOW()     PORTF.OUTCLR = TP_SDI;
#define TP_SDI_HIGH()    PORTF.OUTSET = TP_SDI;

#define TP_CLK_LOW()     PORTF.OUTCLR = TP_CLK;
#define TP_CLK_HIGH()    PORTF.OUTSET = TP_CLK;

#define TOUCH_PRESSED()  !(PORTF.IN & TP_PEN);

#define getTP_SDO()	((PORTF.IN & TP_SDO)>0) ? 1 : 0

#define TC_CR_Y			 0x92 //DFR = 0, PD = 10
#define TC_CR_X			 0xD2 //DFR = 0, PD = 10

#define AD7843_MAX_XVAL	30440
#define AD7843_MAX_YVAL	31136
#define PIXELS_Y        240
#define PIXELS_X        320

typedef struct TP_CAL_POINT
{
	int32_t pixel_X;
	int32_t pixel_Y;
	int32_t ad7843_val_X;
	int32_t ad7843_val_Y;
}TP_CAL_POINT;

extern UTFT utft;

class classAD7843
{
//variables
public:
    uint32_t keyValue;
	char keyValueF[6];
	uint8_t keyValueF_index;
	TP_CAL_POINT Points[2];
protected:
private:
//functions
public:
	classAD7843();
	void TCInit(void);
	unsigned int TCGetX(void); //call this after TCRead() to get X value
	unsigned int TCGetY(void); //call this after TCRead() to get Y value
	unsigned char TCIsPenOn(void); //TC_PEN_PIN is 0 when the screen is pressed
	int16_t ad7843_read(uint8_t);
	void drawKeys(void);
    uint8_t presetKey(void);
	void keyValue_print(uint8_t num);
	void keyValue_print(uint32_t num);
	void keyValue_printF(void);
	~classAD7843();
protected:
private:
	classAD7843( const classAD7843 &c );
	classAD7843& operator=( const classAD7843 &c );
	void drawButton(char * string,uint16_t x, uint16_t y,uint8_t ancho, uint8_t alto);
	void drawTexbox(char * string,uint16_t x, uint16_t y,uint8_t ancho, uint8_t alto);
	uint8_t coll1_decode(void);
	uint8_t coll2_decode(void);
	uint8_t coll3_decode(void);
	uint8_t coll4_decode(void);

}; //classAD7843

#endif //__CLASSAD7843_H__
