/* 
* classGenerator.cpp
*
* Created: 21/03/2015 9:07:24
* Author: Vaio
*/


#include "classGenerator.h"

// default constructor
classGenerator::classGenerator()
{
	curva = Sine;
	Range = Hz_100;
	Ad9837.Frequency = 50;
	encoder_fine_increment = 1;
	encoder_coarse_increment = 10;
	Min_frequency = 1;
	Max_frequency = 100;
} //classGenerator

// default destructor
classGenerator::~classGenerator()
{
} //~classGenerator


void classGenerator::Loop(void)
{
	uint8_t tecla;
	
	if(main_screen)
	{
		mainScreenLoad();
		main_screen = false;
	}
	
	if(Encoder.pulse)
	{
		Encoder.pulse = false;
		Encoder_action();
	}

	if(ENCODER_PUSHED)
	{
		while(ENCODER_PUSHED);
		if(curva != PWM)
		{
		  encoder_fine = !encoder_fine;
		  RangeDisplay();
		}
		  else
		    encoder_frequency = !encoder_frequency;
	}
	
	
	
	if(key_scan)
	{
		key_scan = false;
		if(AD7843.TCIsPenOn())
	    {
			
			if(freq_screen)
			{
				tecla = AD7843.presetKey();
				if(tecla < 10)
				{
				   AD7843.keyValue = AD7843.keyValue * 10UL + tecla;
				   AD7843.keyValue_print(AD7843.keyValue);
				   return;
				}
				if(tecla == 10)//del key
				{
					AD7843.keyValue = 0;
					AD7843.keyValue_print(AD7843.keyValue);
					return;
				}
				if(tecla == 12)//enter key
				{
					Ad9837.Frequency = AD7843.keyValue;
					if(Ad9837.Frequency>Max_frequency)
					 Ad9837.Frequency = Max_frequency;
					if(Ad9837.Frequency<Min_frequency)
					 Ad9837.Frequency = Min_frequency;
					Ad9837.SetFrequency(Ad9837.Frequency);
					set_wave_type();
					func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
					freq_screen = false;
					mainScreenLoad();
				}
				if(tecla == 13)//back key
				{
					freq_screen = false;
					mainScreenLoad();
				}
				
			 }
			 
		 	 if(main_screen_update)
		 	 {
			 	 frequency_key();
			 	 curve_key();
			 	 range_key();
				 inductor_key();
		 	 }
	 
		}
			
	}
	
   
		
}



void classGenerator::func_pwm_update(int32_t freq,int8_t duty)
{
	uint32_t clock;
	if(freq == 0)
	 return;
	if(freq>Max_frequency)
	  freq = Max_frequency;
	if(freq>=500)
	{
		TCC1.CCA = 0;
		TCC1.CTRLA=TC_CLKSEL_DIV1_gc;
		clock = 32000000;
		TCC1.PER = clock / freq;
	}
	
	if((freq<500) & (freq>=10))
	{
		TCC1.CCA = 0;
		TCC1.CTRLA=TC_CLKSEL_DIV256_gc;
		clock = 125000;
		TCC1.PER = clock / freq;
	}
	
	if(freq < 10)
	{
		TCC1.CCA = 0;
		TCC1.CTRLA=TC_CLKSEL_DIV1024_gc;
		clock = 31250;
		TCC1.PER = clock / freq;
	}

	TCC1.CCA =(uint16_t)((uint32_t) duty * (uint32_t)TCC1.PER /100L);
	TCC1.CCB = TCC1.CCA;
}



void classGenerator::mainScreenLoad(void)
{
	uint32_t puntero;
	encoder_frequency = true;
	utft.fillScr(VGA_RED);
	utft.setColor(VGA_WHITE);
	//Marco
	utft.drawRect(1,1,319,239);
	utft.drawRect(2,2,318,238);
	//Recuadro freq
	utft.setColor(VGA_BLACK);
	utft.fillRect(5,5,315,85);
	utft.setColor(VGA_WHITE);
	utft.drawRect(5,5,315,85);
    //Recuadro duty cycle
    utft.setColor(VGA_BLACK);
    utft.fillRect(15,90,305,140);
    utft.setColor(VGA_WHITE);
    utft.drawRect(15,90,305,140);
	//Labels duty
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLACK);
	utft.setFont(font16x16);
	utft.print("Duty Cycle:",30,110,0);
	utft.printNumI(pwm_duty_cycle,235,110,2,' ');
	utft.print("%",280,110,0);
	//Curve type button
	utft.setColor(VGA_BLACK);
	utft.fillRect(15,150,100,230);
	utft.setColor(VGA_WHITE);
	utft.drawRect(15,150,100,230);
	//Curve type text
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLACK);
	utft.setFont(font8x12);
	switch(curva)
	{
		case Sine:
		PORTC.OUTSET = MUX_0;
		PORTC.OUTCLR = MUX_1;
		Ad9837.SetWave(AD9837_OUT_SINUS);
		puntero = pgm_get_far_address(seno);
		utft.drawRGBBitmap_far(15,150,puntero,85,80);
		break;
		case Triangle:
		PORTC.OUTSET = MUX_0;
		PORTC.OUTCLR = MUX_1;
		Ad9837.SetWave(AD9837_OUT_TRIANGLE);
		puntero = pgm_get_far_address(triangle);
		utft.drawRGBBitmap_far(15,150,puntero,85,80);
		break;
		case Square:
		PORTC.OUTCLR = MUX_0;
		PORTC.OUTCLR = MUX_1;
		Ad9837.SetWave(AD9837_OUT_MSB);
		puntero = pgm_get_far_address(squarewave);
		utft.drawRGBBitmap_far(15,150,puntero,85,80);
		break;
		case PWM:
		PORTC.OUTCLR = MUX_0;
		PORTC.OUTSET = MUX_1;
		encoder_frequency = false;
		puntero = pgm_get_far_address(pwmwave);
		utft.drawRGBBitmap_far(15,150,puntero,85,80);
		break;
	}
	//Range button
	utft.setColor(VGA_BLACK);
	utft.fillRect(115,150,200,230);
	utft.setColor(VGA_WHITE);
	utft.drawRect(115,150,200,230);
	//Range text
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLACK);
	utft.setFont(font16x16);
	utft.print("100Hz",120,180,0);
	utft.setFont(font8x12);
	utft.print("Range",130,155,0);
	utft.print("Coarse",130,210,0);
	//Inductor button
	utft.setColor(VGA_BLACK);
	utft.fillRect(220,150,305,230);
	utft.setColor(VGA_WHITE);
	utft.drawRect(220,150,305,230);
	//Ind text
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLACK);
	utft.setFont(font16x16);
	utft.print("Freq",235,180,0);
	/*
	Range = Hz_100;
	Ad9837.Frequency = 100;
	encoder_fine_increment = 1;
	encoder_coarse_increment = 10;
	Min_frequency = 1;
	Max_frequency = 100;
	*/
	displayFreq(Ad9837.Frequency);
	main_screen_update = true;
}

void classGenerator::displayFreq(int32_t f)
{
	
	 utft.setColor(VGA_WHITE);
	 utft.setBackColor(VGA_BLACK);
	 utft.setFont(font7seg);
	 utft.printNumI(f,20,20,7,'0');
	 utft.setFont(font_big);
	 utft.print("Hz",260,20,0);
	 utft.setFont(font16x16);
	 if(curva == PWM)
	    utft.printNumI(pwm_duty_cycle,235,110,2,'0');
		else
            utft.printNumI(50,235,110,2,'0');
}





void classGenerator::mainScreenRefress(void)
{
	char buffer[10];
	sprintf(buffer, "%lu",Ad9837.Frequency);
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLUE);
	utft.setFont(font7seg);
	utft.print(buffer,50,60,0);
	main_screen_update = true;
}



void classGenerator::frequency_key(void)
{
	if (AD7843.TCGetY()>100)
	return;
	if (AD7843.TCGetX()>100 && AD7843.TCGetX()<200)
	{
		main_screen_update = false;
		freq_screen = true;
		keys = false;
		AD7843.drawKeys();
		Max_frequency = 1200000;
		Min_frequency = 1;
		encoder_coarse_increment = 10;
		encoder_fine_increment = 1;
	}
	
}



void classGenerator::curve_key(void)
{
	uint8_t var;
	uint32_t puntero;
	if (AD7843.TCGetY()<100)
	 return;
	if (AD7843.TCGetX()>0 && AD7843.TCGetX()<100)
	{
		utft.setColor(VGA_WHITE);
		utft.setBackColor(VGA_BLACK);
		utft.setFont(font8x12);
		var = (uint8_t)curva;
		var++;
		switch(var)
		{
		    case Sine:
		    PORTC.OUTSET = MUX_0;
		    PORTC.OUTCLR = MUX_1;
			curva = Sine;
			Ad9837.SetWave(AD9837_OUT_SINUS);
			puntero = pgm_get_far_address(seno);
		    utft.drawRGBBitmap_far(15,150,puntero,85,80);
			encoder_frequency = true;
		    break;
		    case Triangle:
		    PORTC.OUTSET = MUX_0;
		    PORTC.OUTCLR = MUX_1;
			curva = Triangle;
			Ad9837.SetWave(AD9837_OUT_TRIANGLE);
			puntero = pgm_get_far_address(triangle);
		    utft.drawRGBBitmap_far(15,150,puntero,85,80);
			encoder_frequency = true;
		    break;
		    case Square:
		    PORTC.OUTCLR = MUX_0;
		    PORTC.OUTCLR = MUX_1;
			Ad9837.SetWave(AD9837_OUT_MSB);
			curva = Square;
			puntero = pgm_get_far_address(squarewave);
		    utft.drawRGBBitmap_far(15,150,puntero,85,80);
			encoder_frequency = true;
		    break;
		    case PWM:
		    PORTC.OUTCLR = MUX_0;
		    PORTC.OUTSET = MUX_1;
			curva = PWM;
			func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
			puntero = pgm_get_far_address(pwmwave);
		    utft.drawRGBBitmap_far(15,150,puntero,85,80);
			encoder_frequency = false;
		    break;
			default:
			curva = Sine;
			PORTC.OUTSET = MUX_0;
			PORTC.OUTCLR = MUX_1;
			Ad9837.SetWave(AD9837_OUT_SINUS);
			puntero = pgm_get_far_address(seno);
			utft.drawRGBBitmap_far(15,150,puntero,85,80);
			encoder_frequency = true;
			break;;
		}
        displayFreq(Ad9837.Frequency);

	}
}


void classGenerator::range_key(void)
{
	uint8_t var;
	if (AD7843.TCGetY()<100)
	return;
	if (AD7843.TCGetX()>100 && AD7843.TCGetX()<220)
	{
		utft.setColor(VGA_WHITE);
		utft.setBackColor(VGA_BLACK);
		utft.setFont(font16x16);
		var = (uint8_t)Range;
		var++;
		switch(var)
		{
			case Hz_100:
			Range = Hz_100;
			Ad9837.Frequency = 50;
			encoder_fine_increment = 1;
			encoder_coarse_increment = 10;
			Min_frequency = 1;
			Max_frequency = 100;
			break;
			case kHz_1:
			Range = kHz_1;	
			Ad9837.Frequency = 500;
			encoder_fine_increment = 10;
			encoder_coarse_increment = 100;
			Min_frequency = 50;
			Max_frequency = 1000;
			break;
			case kHz_20:
		    Range = kHz_20;
			Ad9837.Frequency = 10000;
			encoder_fine_increment = 200;
			encoder_coarse_increment = 2000;
			Min_frequency = 20;
			Max_frequency = 20000;
			break;
			case kHz_100:
			Range = kHz_100;
			Ad9837.Frequency = 50000;
			encoder_fine_increment = 1000;
			encoder_coarse_increment = 10000;
			Min_frequency = 1000;
			Max_frequency = 100000;
			break;
            case kHz_400:
            Range = kHz_400;
            Ad9837.Frequency = 200000;
			encoder_fine_increment = 4000;
			encoder_coarse_increment = 40000;
			Min_frequency = 10000;
            Max_frequency = 400000;
			break;
			case MHz_1:
			Range = MHz_1;
			Ad9837.Frequency = 500000;
			encoder_fine_increment = 10000;
			encoder_coarse_increment = 50000;
			Min_frequency = 10000;
			Max_frequency = 1200000;
			break;
			default:
			Range = Hz_100;
			Ad9837.Frequency = 100;
			encoder_fine_increment = 1;
			encoder_coarse_increment = 10;
			Min_frequency = 1;
			Max_frequency = 100;
			break;
		}
		Ad9837.SetFrequency(Ad9837.Frequency);
		set_wave_type();
		func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
        displayFreq(Ad9837.Frequency);
        RangeDisplay();
	}
}

void classGenerator::RangeDisplay(void)
{
	//Range text
	utft.setColor(VGA_WHITE);
	utft.setBackColor(VGA_BLACK);
	utft.setFont(font16x16);
	switch(Range)
	{
		case Hz_100:
		utft.print("100Hz",120,180,0);
		break;
		case kHz_1:
		utft.print("1 KHz",120,180,0);
		break;
		case kHz_20:
		utft.print("20kHz",120,180,0);
		break;
		case kHz_100:
		utft.print("100 K",120,180,0);
		break;
		case kHz_400:
		utft.print("400 K",120,180,0);
		break;
		case MHz_1:
		utft.print("1 MHz",120,180,0);
		break;
		
	}
	utft.setFont(font8x12);
	utft.print("Range",130,155,0);
	if(encoder_fine)
	  utft.print("Fine  ",130,210,0);
	   else
	    utft.print("Coarse",130,210,0);
	
}

//Salto a pantalla Inductor test
void classGenerator::inductor_key(void)
{
	if (AD7843.TCGetY()<100)
	return;
	if ((AD7843.TCGetX()>220) && (AD7843.TCGetX()<320))
	{
		main_screen_update = false;
		freq_screen = true;
		keys = false;
		AD7843.drawKeys();
		Max_frequency = 1200000;
		Min_frequency = 1;
		encoder_coarse_increment = 10;
		encoder_fine_increment = 1;

	}

}

void classGenerator::Encoder_action(void)
{
	if(Encoder.direction)
	{
		if(encoder_frequency)
		{
			if(encoder_fine)
			{
				Ad9837.Frequency +=encoder_fine_increment;
				if(Ad9837.Frequency>Max_frequency)
				 Ad9837.Frequency = Max_frequency;
				Ad9837.SetFrequency(Ad9837.Frequency);
				set_wave_type();
			    func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
			    displayFreq(Ad9837.Frequency);
				return;
			}
	
		    Ad9837.Frequency +=encoder_coarse_increment;
			
		}
		else //duty_cycle
		{
			pwm_duty_cycle++;
			if(pwm_duty_cycle>MAX_DUTY_CYCLE)
			 pwm_duty_cycle = MAX_DUTY_CYCLE;
		}
	}
	else
	
	{
		if(encoder_frequency)
		{
			if(encoder_fine)
			{
				Ad9837.Frequency -=encoder_fine_increment;
				if(Ad9837.Frequency < Min_frequency)
				 Ad9837.Frequency = Min_frequency;
				Ad9837.SetFrequency(Ad9837.Frequency);
				set_wave_type();
			    func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
			    displayFreq(Ad9837.Frequency);
				return;
			}

		    Ad9837.Frequency -=encoder_coarse_increment;
			
		}
		else //duty_cycle
		{
			pwm_duty_cycle--;
			if(pwm_duty_cycle<MIN_DUTY_CYCLE)
			pwm_duty_cycle = MIN_DUTY_CYCLE;
			
		}
	}//end Encoder.direction
	if(Ad9837.Frequency < Min_frequency)
	 Ad9837.Frequency = Min_frequency;
	if(Ad9837.Frequency>Max_frequency)
	 Ad9837.Frequency = Max_frequency;
	Ad9837.SetFrequency(Ad9837.Frequency);
	set_wave_type();
	func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
	displayFreq(Ad9837.Frequency);
}


//Se usa al cambiar la freq desde el Encoder
void classGenerator::set_wave_type(void)
{
	switch(curva)
	{
		    case Sine:
		    PORTC.OUTSET = MUX_0;
		    PORTC.OUTCLR = MUX_1;
		    Ad9837.SetWave(AD9837_OUT_SINUS);
		    //encoder_frequency = true;
		    break;
		    case Triangle:
		    PORTC.OUTSET = MUX_0;
			PORTC.OUTCLR = MUX_1;
		    Ad9837.SetWave(AD9837_OUT_TRIANGLE);
		    //encoder_frequency = true;
		    break;
		    case Square:
		    PORTC.OUTCLR = MUX_0;//OUTSET
		    PORTC.OUTCLR = MUX_1;
		    Ad9837.SetWave(AD9837_OUT_MSB);
		    //encoder_frequency = true;
		    break;
		    case PWM:
		    PORTC.OUTCLR = MUX_0;
		    PORTC.OUTSET = MUX_1;
		    func_pwm_update(Ad9837.Frequency,pwm_duty_cycle);
		    //encoder_frequency = false;
		    break;
		    default:
		    curva = Sine;
		    PORTC.OUTSET = MUX_0;
		    PORTC.OUTCLR = MUX_1;
		    Ad9837.SetWave(AD9837_OUT_SINUS);
		    //encoder_frequency = true;
		    break;;
	    }
	
}




//Pertenece a calibration screen
void classGenerator::Return_key(void)
{
	if (AD7843.TCGetY()<150)
	return;
	if (AD7843.TCGetX()>200 && AD7843.TCGetX()<320)
	{
		main_screen = false;
		//current_set = false;
		//r_set = false;
		mainScreenLoad();
		_delay_ms(400);
	}
	
}














