/* 
* classGenerator.h
*
* Created: 21/03/2015 9:07:24
* Author: Vaio
*/


#ifndef __CLASSGENERATOR_H__
#define __CLASSGENERATOR_H__

#include <avr/io.h>
#include <math.h>
#include <stdio.h>
//#include <stdlib.h>
#include "classAD7843.h"
#include "UTFT.h"
//#include "classAD5932.h"
#include "classAd9837.h"
#include "tipos.h"

//#define MAX_FREQUENCY        2000000
//#define MIN_FREQUENCY        1
#define MAX_DUTY_CYCLE       99
#define MIN_DUTY_CYCLE       1

typedef enum CURVAS
{
	Sine,
	Triangle,
	Square,
	PWM
	}CURVAS;

typedef enum RANGOS
{
	Hz_100,
	kHz_1,
	kHz_20,
	kHz_100,
	kHz_400,
	MHz_1
}RANGOS;




extern UTFT utft;
extern classAD7843 AD7843;
//extern classAD5932 Ad5932;
extern classAd9837 Ad9837;
class classGenerator
{
//variables
public:
   volatile bool key_scan;
   int8_t pwm_duty_cycle;

protected:
private:
    CURVAS curva;
    RANGOS Range;
    int32_t encoder_coarse_increment;
    int32_t encoder_fine_increment;
    int16_t pwm_frequency;
    bool main_screen;
    bool freq_screen;
    bool main_screen_update;
    bool keys;
    bool encoder_frequency;
    bool encoder_fine;
    uint8_t ARRAY_LENGHT;
    int16_t points[64];
	uint8_t point;
	int32_t Min_frequency;
	int32_t Max_frequency;

//functions
public:
	classGenerator();
	~classGenerator();
	void Loop(void);
    void displayFreq(int32_t f);
	void mainScreenLoad(void);
protected:
private:
	classGenerator( const classGenerator &c );
	classGenerator& operator=( const classGenerator &c );
	void mainScreenRefress(void);
	void frequency_key(void);
	void curve_key(void);
	void range_key(void);
	void inductor_key(void);
	void Return_key(void);
    void Encoder_action(void);
	void func_pwm_update(int32_t freq,int8_t duty);
	void set_wave_type(void);
    void RangeDisplay(void);
}; //classGenerator

#endif //__CLASSGENERATOR_H__
