/***
 * IIR Filter Library - Definitions and constants
 *
 * Copyright (C) 2016  Martin Vincent Bloedorn
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

// Uncomment to use `double` instead of `float` for all library functions.
//#define LIBFILTER_USE_DOUBLE

#include <stdint.h>
#include <math.h>
#include <stdlib.h>


  const uint8_t MAX_ORDER = 5;
  
  typedef enum ORDER 
  {
	  OD1 = 0, 
	  OD2,
	  OD3,
	  OD4
	  }ORDER;
	  
  typedef enum TYPE
  {
	  LOWPASS,
	  HIGHPASS
	  }TYPE;	  

  const float SQRT2 = sqrt(2.0);
  const float SQRT3 = sqrt(3.0);
  const float SQRT5 = sqrt(5.0);

  const float EPSILON   = 0.00001;    // Tolerance for numerical constants
  const float WEPSILON  = 0.00010;    // Warning threshold for numerical degradation
  const float KM        = 100.0;      // Pre-multiplier to reduce the impact of the AVRs limited float representation

