/*
 * tft2_8_board.cpp
 *
 * Created: 02/02/2015 11:28:22
 *  Author: Vaio
 */ 


#include <avr/io.h>
#include "main.h"


/*****************************************************************
* PORTC interrupt 0 service routine
* Interrupcion del Touch Pannel
* Ocurre cada vez que se pulsa la pantalla.
*****************************************************************
ISR(PORTC_INT0_vect)
{
	contadores.segundos = 0;
	//flags.leer_AD7843 = true;
}
*/




/*****************************************************************
* Base de tiempo de 10 ms.
* Llamada a los menus
******************************************************************/
 ISR(RTC_OVF_vect)
 {
	contadores.led_blinking++;
	contadores.timebase_sg++;
 }
 
 
 
 
/***************************************************************
* Interrupcion generada por los flanco de caida de la seal
* del canal A del Encoder.
***************************************************************/
ISR(PORTD_INT0_vect)
{
	if(PORTD.IN & PIN0_bm)
	{
		if(PORTD.IN & PIN1_bm)
		{
			Encoder.direction = false;
			Encoder.pulse_counter--;
		}
		else
		{
			Encoder.direction = true;
			Encoder.pulse_counter++;
		}
		
	}
	else
	{
		if(PORTD.IN & PIN1_bm)
		{
			Encoder.direction = true;
			Encoder.pulse_counter++;
		}
		else
		{
			Encoder.direction = false;
			Encoder.pulse_counter--;
		}
		
	}
	
	Encoder.pulse = true;
	
}


int main(void)
{
	int16_t adc_value;
	clock.system_clocks_init();
	Ports.ports_init();
	SPIe.spi_init(SPI_MODE_0_gc);
	Timers.tcc1_init();//PWM signal generation
	Rtc.rtc_init();
	interrupts_config();
	event_system_init();
	utft.disp_x_size = 320;
	utft.disp_y_size = 240;
	utft.InitLCD(LANDSCAPE);
	AD7843.TCInit();
	page = 0;
	
	Ad9837.Reset();
	
	if(eeprom_read_byte(&eep_writed) != 1)
	 set_defaults();
	eeprom_read(); 
	
	Ad9837.Frequency = 50;
	Ad9837.SetFrequency(Ad9837.Frequency);
	Ad9837.SetWave(AD9837_OUT_SINUS);
	Ad9837.SetPhase(AD9837_REG_PHASE0,0);
	Ad9837.ClearReset();
	Generator.pwm_duty_cycle = 30;
	Generator.mainScreenLoad();
    while(1)
    {
        if(contadores.led_blinking >14)
        {
	       contadores.led_blinking = 0;
	       PORTE.OUTTGL= LED_bm;
		   Generator.key_scan = true;
		   Generator.Loop();
        } 
		
		if(contadores.timebase_sg>=50)
		{
			contadores.timebase_sg = 0;

		}
		
		
	}
}


void interrupts_config(void)
{
	// Low level interrupt: On
	// Round-robin scheduling for low level interrupt: On
	// Medium level interrupt: On
	// High level interrupt: On
	// The interrupt vectors will be placed at the start of the Application FLASH section
	unsigned char n;
	n=(PMIC.CTRL & (~(PMIC_RREN_bm | PMIC_IVSEL_bm | PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm))) |
	PMIC_LOLVLEN_bm | PMIC_RREN_bm | PMIC_MEDLVLEN_bm | PMIC_HILVLEN_bm;
	CCP=CCP_IOREG_gc;
	PMIC.CTRL=n;
	// Set the default priority for round-robin scheduling
	PMIC.INTPRI=0x00;
	asm("sei");
}


// Event System initialization
void event_system_init(void)
{
	// Event System Channel 0 source: Timer/Counter E0 Overflow
	EVSYS.CH0MUX=EVSYS_CHMUX_TCE0_OVF_gc;
	// Event System Channel 1 source: None
	EVSYS.CH1MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 2 source: None
	EVSYS.CH2MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 3 source: None
	EVSYS.CH3MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 4 source: None
	EVSYS.CH4MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 5 source: None
	EVSYS.CH5MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 6 source: None
	EVSYS.CH6MUX=EVSYS_CHMUX_OFF_gc;
	// Event System Channel 7 source: None
	EVSYS.CH7MUX=EVSYS_CHMUX_OFF_gc;

	// Event System Channel 0 Digital Filter Coefficient: 1 Sample
	// Quadrature Decoder: Off
	EVSYS.CH0CTRL=(EVSYS.CH0CTRL & (~(EVSYS_QDIRM_gm | EVSYS_QDIEN_bm | EVSYS_QDEN_bm | EVSYS_DIGFILT_gm))) |
	EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 1 Digital Filter Coefficient: 1 Sample
	EVSYS.CH1CTRL=EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 2 Digital Filter Coefficient: 1 Sample
	// Quadrature Decoder: Off
	EVSYS.CH2CTRL=(EVSYS.CH2CTRL & (~(EVSYS_QDIRM_gm | EVSYS_QDIEN_bm | EVSYS_QDEN_bm | EVSYS_DIGFILT_gm))) |
	EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 3 Digital Filter Coefficient: 1 Sample
	EVSYS.CH3CTRL=EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 4 Digital Filter Coefficient: 1 Sample
	// Quadrature Decoder: Off
	EVSYS.CH4CTRL=(EVSYS.CH4CTRL & (~(EVSYS_QDIRM_gm | EVSYS_QDIEN_bm | EVSYS_QDEN_bm | EVSYS_DIGFILT_gm))) |
	EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 5 Digital Filter Coefficient: 1 Sample
	EVSYS.CH5CTRL=EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 6 Digital Filter Coefficient: 1 Sample
	EVSYS.CH6CTRL=EVSYS_DIGFILT_1SAMPLE_gc;
	// Event System Channel 7 Digital Filter Coefficient: 1 Sample
	EVSYS.CH7CTRL=EVSYS_DIGFILT_1SAMPLE_gc;

	// Event System Channel output: Disabled
	PORTCFG.CLKEVOUT&= ~PORTCFG_EVOUT_gm;
	PORTCFG.EVOUTSEL&= ~PORTCFG_EVOUTSEL_gm;
}





void set_defaults(void)
{
	eeprom_write_byte(&eep_writed,1);
}

void eeprom_read(void)
{
}

float string2float(const char* s)
{
	float rez = 0, fact = 1;
	if (*s == '-'){
		s++;
		fact = -1;
	};
	for (int point_seen = 0; *s; s++){
		if (*s == '.'){
			point_seen = 1;
			continue;
		};
		int d = *s - '0';
		if (d >= 0 && d <= 9){
			if (point_seen) fact /= 10.0f;
			rez = rez * 10.0f + (float)d;
		};
	};
	return rez * fact;
};


