/*
 * main.h
 *
 * Created: 30/01/2015 10:35:43
 *  Author: Vaio
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#include "tipos.h"
#include <avr/io.h>
#include <avr/portpins.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <stdbool.h>
#include <math.h>
#define F_CPU (32000000UL)
#include <util/delay.h>
#include "classSPI.h"
#include "classClock.h"
#include "classPorts.h"
#include "classTimers.h"
#include "UTFT.h"
#include "classAD7843.h"
#include "classXmegaRtc.h"
#include "classGenerator.h"
//#include "classAD5932.h"
#include "classAd9837.h"




/******************************************************************************
**  Variables globales
******************************************************************************/


PARAMETROS Params;

EEMEM uint8_t eep_writed;
FLAGS flags;
CONTADORES contadores;

uint16_t page;
uint16_t x,y,ancho,alto;
uint32_t address;
classClock clock;
classSPI SPIe(&SPIE);
classPorts Ports;
classTimers Timers;
classXmegaRtc Rtc;
UTFT utft;
classAD7843 AD7843;
classGenerator Generator;
//classAD5932 Ad5932;
classAd9837 Ad9837;
ENCODER Encoder;
uint16_t fase;
//Prototipos
void interrupts_config(void);
void event_system_init(void);
void rs485_cmd_decode(uint8_t);
void set_defaults(void);
void eeprom_read(void);
float string2float(const char* s);
//void fillTriangle(uint8_t x,uint8_t y,uint8_t l,uint8_t h);
#endif /* MAIN_H_ */