
#ifndef TIPOS_H_
#define TIPOS_H_

#include <avr/io.h>
#include <avr/portpins.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <stdbool.h>

/* INPUT PIN DEFINITION******************************************************/
#define TA          PIN0_bm           //PORTA
#define TB          PIN1_bm           //PORTA
#define ANA2        PIN2_bm           //PORTA
#define DIO4        PIN4_bm           //PORTA
#define DIO5        PIN5_bm           //PORTA
#define DIO6        PIN6_bm           //PORTA
#define DIO7        PIN7_bm           //PORTA

/**************************************************************************
* INPUT PINS DEFINITIONS
***************************************************************************/
//#define TP_PEN                     !(PORTF.IN & PIN3_bm)   
#define ENCODER_PUSHED               !(PORTD.IN & PIN2_bm)   

/* OUTPUT PIN DEFINITION******************************************************/

#define LED_bm      PIN0_bm           //PORTE
#define DE          PIN1_bm           //PORTE
#define DAC         PIN2_bm           //PORTB
#define MUX_0       PIN6_bm           //PORTC
#define MUX_1       PIN7_bm           //PORTC




typedef struct PARAMETROS
{
	}PARAMETROS;
	
extern PARAMETROS Params;

typedef struct FLAGS
{
	volatile bool leer_AD7843;
	
}FLAGS;
extern FLAGS flags;// __attribute__((__section__(".noinit")));

typedef struct CONTADORES
{
	volatile unsigned int led_blinking;            //parpadeo del led
	volatile unsigned int timebase_sg;             //base de tiempo segundos
}CONTADORES;
extern CONTADORES contadores;// __attribute__((__section__(".noinit"))) ;

typedef struct ENCODER
{
	int8_t pulse_counter;
	bool direction;
	bool pulse;
	bool push;
}ENCODER;
extern ENCODER Encoder;
extern float string2float(const char* s);
extern void set_defaults(void);
#endif /* TIPOS_H_ */